////////////////////////////////////////////////////////////////////////////
// SHRIEK OF THE LIVING DEAD, (c)2006 CLAUS NIELSEN & ROD FISHER
// Programming: Claus Nielsen   Modeling, Graphics & Music: Rod Fisher
// Created for the Caiman Easter game contest.
////////////////////////////////////////////////////////////////////////////
var video_mode = 7;	 // screen size 640x480
var video_depth = 16; // 16 bit colour D3D mode
var video_screen = 1;
/////////////////////////////////////////////////////////////////
string level_str = <Ball1.WMB>; // give file names in angular brackets
bind <zombie.mdl>;
bind <bunny.mdl>;
bind <zombie.wav>;
bind <bunny.wav>;
bind <shriek.mid>;
sound gong_wav = <gong.wav>;
sound zombie_wav = <aargh.wav>;
sound snd_fx1 = <zombie.wav>;
sound snd_fx2 = <zombie1.wav>;
sound snd_fx3 = <zombie2.wav>;
sound snd_fx4 = <zombie3.wav>;
sound snd_fx5 = <zombie4.wav>;
sound bunny_wav = <bunny.wav>;
sound chip_clik = <chip_click.wav>;


bmap splashmap = <logolite.pcx>; // the default logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
	
}

///////////////////////////////////////////////////////////////////////////////////
define moving,flag1;
define speed_x,skill1;
define speed_y,skill2;
define health,skill3;
define id,skill4;
define enemy,1;
entity* ball;

function _ball();
function enemy_();
bmap mouse_pcx = <mouse.pcx>;
var created_ents;
var enemy_waiting;
var difficult;
var cross_stat;
var _score;
var _time=0;
var _level;
var filehandle;
var_nsave stop_mid;

bmap menu_map = <menu.tga>;
bmap options_map = <back_options.tga>;
bmap choose_diffi = <diffi.tga>;
bmap slider_map = <slider.tga>;
bmap ok_button = <ok_but.tga>;
bmap continue_button = <continue_but.tga>;
bmap play_button = <play_but.tga>;
bmap rec_button = <records_but.tga>;
bmap options_button = <options_but.tga>;
bmap exit_button = <exit_but.tga>;

font Ball_font, "Arial",1,18;//<bfont.bmp>, 15, 14;

var e_records[3];
var m_records[3];
var h_records[3];

string easy1[25];
string easy2[25];
string easy3[25];
string medi1[25];
string medi2[25];
string medi3[25];
string hard1[25];
string hard2[25];
string hard3[25];

font arial_font = "Arial",1,18;

bmap score_map = <back_score.tga>;

panel high_score()
{
	bmap = score_map;
	button = 170,230,ok_button,ok_button,ok_button,menu_show,null,null;
	digits = 130,40,3,arial_font,1,e_records[0];
	digits = 130,55,3,arial_font,1,e_records[1];
	digits = 130,70,3,arial_font,1,e_records[2];
	digits = 130,120,3,arial_font,1,m_records[0];
	digits = 130,135,3,arial_font,1,m_records[1];
	digits = 130,150,3,arial_font,1,m_records[2];
	digits = 130,202,3,arial_font,1,h_records[0];
	digits = 130,217,3,arial_font,1,h_records[1];
	digits = 130,232,3,arial_font,1,h_records[2];
}

panel menu_difficult()
{
	bmap = choose_diffi;
	layer = 5;
	flags = overlay,refresh;
	button = 80,150,ok_button,ok_button,ok_button,start_the_game1,null,null;
	button = 170,150,ok_button,ok_button,ok_button,start_the_game2,null,null;
	button = 260,150,ok_button,ok_button,ok_button,start_the_game3,null,null;
}

function menu_score_show();
function score_txt_hide();

panel menu_back()
{
	bmap = menu_map;
	layer = 7;
	flags = refresh;
	button = 150,85,continue_button,continue_button,continue_button,continue_game,null,null;
	button = 150,125,play_button,play_button,play_button,menu_diffi_show,null,null;
	button = 150,165,rec_button,rec_button,rec_button,menu_score_show,null,null;
	button = 150,205,options_button,options_button,options_button,menu_options_show,null,null;
	button = 150,245,exit_button,exit_button,exit_button,exit_game,null,null;	
}

var new_video;
var new_depth;
var camera_ambient = 100;

panel menu_options()
{
	bmap = options_map;
	layer = 6;
	flags = refresh;
	hslider = 133,96,134,slider_map,5,8,new_video;
	hslider = 133,136,134,slider_map,1,2,new_depth;
	hslider = 133,176,134,slider_map,0,200,camera_ambient;
	button = 170,230,ok_button,ok_button,ok_button,change_res,null,null;
}

function rewrite_high_score();

function exit_game()
{
	rewrite_high_score();
	wait(2);
	exit;
}
bmap bunny_win = <bunny_saved.pcx>;
bmap continue_but1 = <continue_but1.bmp>;
bmap continue_but2 = <continue_but2.bmp>;
bmap menu_but = <menu_but.bmp>;
bmap menu_but2 = <menu_but2.bmp>;
bmap quit_but = <quit_but.bmp>;
bmap quit_but2 = <quit_but2.bmp>;
panel success
{
	bmap = bunny_win;
	button = 100,525,menu_but,menu_but,menu_but2,menu_show,null,null;
	button = 360,525,continue_but1,continue_but1,continue_but2,continue_game1,null,null;
	button = 630,525,quit_but,quit_but,quit_but2,exit_game,null,null;
	layer = 2;
}

text times_up
{
	pos_x = 140;
	pos_y = 34;
	layer = 4;
	font = ball_font;
	string = "SORRY...YOU ARE OUT OF TIME";
	flags = outline;
	red = 45;  //change numbers for different color, delete for white
  green = 211;
  blue = 0;	
}

text click_mouse
{
	pos_y = 100;
 layer = 4;
 font = ball_font;
 string = "Click Mouse to Start";
 flags = outline,center_x;    // Center the text
 red = 45;  
  green = 211;
  blue = 0; 
}
 
function to_start()
{
 click_mouse.pos_x = screen_size.x / 2;    // center the text
 click_mouse.visible = on;
 sleep(4);
 click_mouse.visible = off;
 return;
}

text bunny_dead
{
	pos_x = 140;
	pos_y = 34;
	layer = 4;
	font = ball_font;
	string = "SORRY...BUNNY IS DEAD.";
	flags = outline;
	red = 45;  //change numbers for different color, delete for white
  green = 211;
  blue = 0;	
}

sound buzzer_wav = <buzzer.wav>;
sound applause_wav = <applause.wav>;
function bunny_saved()
{

	if(ball.health >= 1)&&(_time>= 0)&&( _score == 100)
//||(difficult == 40 && _score == 100)||(difficult >= 50 && _score == 100)))
 

	{
		success.pos_x =(screen_size.x - bmap_width(bunny_win))/2;
		success.pos_y = (screen_size.y - bmap_height(bunny_win))/2;
		success.visible = on;
		freeze_mode = 1;
		stop_bg_music();
		snd_play(applause_wav,100,0);		
		
	}
	If(_time <= 0)&&(_score < 100)
	{
		check_score();
		menu_score_show();
		times_up.visible = on;
		snd_play(buzzer_wav,100,0);
		sleep(1);		
		times_up.visible = off;
		sleep(1);
		times_up.visible = on;
		snd_play(buzzer_wav,100,0);
		sleep(1);
		times_up.visible = off;
		sleep(1);
		times_up.visible = on;
		sleep(1);
		times_up.visible = off;		
	}
	
}

function die_bunny()
{
	IF(ball.health <= 0)
	{
		bunny_dead.visible = on;
		sleep(3);
		bunny_dead.visible = off;
	}
}

bmap help_pan_pcx = <help_pan.pcx>;
panel show_help_pan
{
	bmap = help_pan_pcx;
	button = 150,250,continue_button,continue_button,continue_button,continue_game,null,null;
	
	layer = 7;
	flags = refresh, d3d;
}

function help_show()
{
	if(menu_back.visible == off)
	{
	freeze_mode = 1;
	snd_play(chip_clik,100,0);
	show_help_pan.visible = on;
	show_help_pan.pos_x = (screen_size.x-bmap_width(choose_diffi))/2;
	show_help_pan.pos_y = (screen_size.y-bmap_height(choose_diffi))/2;
	}
}

bmap help_pan_button = <help_bg.pcx>;
bmap help_but = <help_but.pcx>;
bmap help_but2 = <help_but2.pcx>;
panel button_help
{
	bmap = help_pan_button;
	pos_x = 20;
	pos_y = 85;
	button = 0,0,help_but,help_but,help_but2,help_show,null,null;
	flags = refresh,d3d, overlay;
	
}

function button_help_show()
{	
	button_help.visible = on;
}

function continue_game1()
{
	success.visible = off;
//	if(difficult <= 30){	_score = 125;}
//	if(difficult == 40){	_score = 175;}
//	if(difficult >= 50){	_score = 225;}
	_score = 125;
	_time = 1000;
	start_BG_music();
	if(difficult < 1) {return;}
	show_help_pan.visible = off;
	menu_back.transparent = on;
	high_score.visible = off;
	menu_options.visible = off;
	menu_difficult.visible = off;
	score_txt_hide();
	while(menu_back.alpha > 5)
	{
		menu_back.alpha -= 20*time;
		wait(1);
	}
	menu_back.visible = off;
	menu_back.alpha = 100;
	menu_back.transparent = off;
	freeze_mode = 0;

}

function continue_game()
{
	
	start_BG_music();
	if(difficult < 1) {return;}
	show_help_pan.visible = off;
	menu_back.transparent = on;
	high_score.visible = off;
	menu_options.visible = off;
	menu_difficult.visible = off;
	score_txt_hide();
	while(menu_back.alpha > 5)
	{
		menu_back.alpha -= 20*time;
		wait(1);
	}
	menu_back.visible = off;
	menu_back.alpha = 100;
	menu_back.transparent = off;
	freeze_mode = 0;

}

function menu_diffi_show()
{
	
	high_score.visible = off;
	menu_options.visible = off;
	menu_back.visible = off;
	score_txt_hide();
	menu_difficult.visible = on;
	menu_difficult.pos_x = (screen_size.x-bmap_width(choose_diffi))/2;
	menu_difficult.pos_y = (screen_size.y-bmap_height(choose_diffi))/2;
	freeze_mode = 1;
}

function menu_options_show()
{
	
	high_score.visible = off;
	menu_options.visible = on;
	menu_difficult.visible = off;
	score_txt_hide();
	menu_back.visible = off;
	menu_options.pos_x = (screen_size.x-bmap_width(choose_diffi))/2;
	menu_options.pos_y = (screen_size.y-bmap_height(choose_diffi))/2;
	freeze_mode = 1;
}

function menu_show()
{
	SUCCESS.VISIBLE = OFF;
	snd_play(chip_clik,100,0);
	inkey_active = off;
	high_score.visible = off;
	menu_options.visible = off;
	menu_difficult.visible = off;
	score_txt_hide();
	menu_back.visible = on;
	menu_back.pos_x = (screen_size.x-bmap_width(choose_diffi))/2;
	menu_back.pos_y = (screen_size.y-bmap_height(choose_diffi))/2;
	freeze_mode = 1;

}
var res_changed;
function change_res()
{
	res_changed = 1;
	new_video = int(new_video)+2;
	new_depth = int(new_depth);
	if(new_depth == 1) {new_depth = 16;}
	else {new_depth = 32;}
	if(new_depth == video_depth) {new_depth = 0;}
	if(new_video == video_mode) {new_video = 0;}
	video_switch(new_video,new_depth,0);
	new_video = video_mode;
	new_depth = video_depth/16;
	menu_show();
	wait(2);
	mouse_cross();
}

on_esc = menu_show;
///////////////////////////////////////////////////////////////////////////////////
function mouse_cross();
function show_health();
function check_score();
function read_high_score();
/////////////////////////////////////////////////////////////////
function main_part2();

function main()
{
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_level = 0;
	_time = 0;
	stats_off();
	mouse_mode = 1;
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
	wait(3);
	level_load(level_str);
	freeze_mode = 1;
	sleep(2);
	snd_play(gong_wav,100,50);
	sleep(2);
	snd_play(zombie_wav,100,0);
	sleep(6);
  	splashscreen.visible = off;
	bmap_purge(splashmap);	// remove splashscreen from video memory
	stats_on();
	freeze_mode = 0;
	new_video = video_mode;
	new_depth = 1;
	midi_vol = 65;
	main_part2();
	menu_show();
	start_BG_music();
	read_high_score();
		
}


function main_part2()
{
button_help_show();
success.visible = off;
camera.x = 0;
camera.y = -700;//-550;
camera.z = 200;//650;
camera.pan = 90;
camera.tilt = -20;//-60;
mouse_cross();
	ent_create("bunny.mdl",vector(0,0,-115),_ball);
	mouse_mode = 2;
	show_health();
	while(ball == null) {wait(1);}
	while(ball != null)
	{
		
		if(ball != null)
		{
			if(enemy_waiting < 1&&freeze_mode == 0&&ball.moving == on)
			{
				temp.x = random(360)-random(360);
				temp.y = random(550)-random(400);
				ent_create("zombie.mdl",vector(temp.x,temp.y,115),enemy_);
				
				if(_level < 5)
				{
					if(difficult < 30) {enemy_waiting = 22 - _level;}
					if(difficult == 40) {enemy_waiting = 17 - (_level * 2);}
					if(difficult > 50) {enemy_waiting = 13 - int(_level*0.5);}
				}
				else
				{
					if(difficult < 30) {enemy_waiting = 20 - 4;}
					if(difficult == 40) {enemy_waiting = 17 - 8;}
					if(difficult > 50) {enemy_waiting = 10 - 4;}
				}
				
			}
			if(menu_difficult.visible == off&&ball.moving == on) {enemy_waiting -= 1*time;}
			if((freeze_mode == 0) && (ball.speed_x != 0)) 
				{
					_time -= 1*time;
					_level = int((_score + 1) / 20);	//was 10
					bunny_saved();	
				}
		}
		wait(1);
	}
	start_bg_music();
}

action board
{
	my.alpha = 50;
}

action sky
{
	my.ambient = 100;
	my.transparent = on;
	my.alpha = 30;
	while(1)
	{
		my.pan += 0.05*time;
		my.tilt += 0.05*time;
		my.roll += 0.05*time;
		wait(1);
	}
}

string shriek_mid = <shriek.mid>;
function start_BG_music()
{
media_loop("shriek.mid", null, 80);
	stop_mid = media_handle;
	return;	
}

function stop_BG_music()
{
media_loop("shriek.mid", null, 0);
return;	
}

var ran_snd=0;

function random_groans() //zombie groans
{
	 randomize();
	  ran_snd = int(random(5));
	  if(ran_snd == 0) {snd_play(snd_fx1,50,0); }
	  if(ran_snd == 1) {snd_play(snd_fx2,50,0); }
	  if(ran_snd == 2) {snd_play(snd_fx3,50,0); }
	  if(ran_snd == 3) {snd_play(snd_fx4,50,0); }
	  if(ran_snd == 4) {snd_play(snd_fx5,50,0); }
	  	
} 

function start_the_game1()
{
	
	if(ball != null) {ent_remove(ball);}
	level_load(level_str);
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_level = 0;
	_time = 2200;
	wait(3);
	main_part2();
	difficult = 20;
	menu_difficult.visible = off;
	freeze_mode = 0;
	to_start();
}

function start_the_game2()
{	
	if(ball != null) {ent_remove(ball);}
	level_load(level_str);
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_level = 0;
	_time = 1700;
	wait(3);
	main_part2();
	difficult = 40;
	menu_difficult.visible = off;
	freeze_mode = 0;
	to_start();
}

function start_the_game3()
{	
	if(ball != null) {ent_remove(ball);}
	level_load(level_str);
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_level = 0;
	_time = 1500;
	wait(3);
	main_part2();
	difficult = 60;
	menu_difficult.visible = off;
	freeze_mode = 0;
	to_start();
}

function ball_eve();
function ball_hit();

function ball_event()
{
	if((event_type == event_entity) || (event_type == event_block))
	{
		ball_hit();
		if(you != null)
		 {
		 	if(you.id == enemy)&&(difficult <= 30 ) 
		 	{
		 		my.health -= 6;
		 		snd_play(bunny_wav,50,0);
		 	}
		 	if(you.id == enemy)&&(difficult == 40 ) 
		 	{
		 		my.health -= 7;
		 		snd_play(bunny_wav,50,0);
		 	}
		 	if(you.id == enemy)&&(difficult >= 50 ) 
		 	{
		 		my.health -= 8;
		 		snd_play(bunny_wav,50,0);
		 	}
		 }
		if(random(1) > 0.5)
		{
			my.pan += 60+random(60);
		}
		else
		{
			my.pan -= 60+random(60);
		}
		return;
	}
	if((event_type == event_touch) || (event_type == event_release))
	{
		ball_eve();
	}
	die_bunny();
}

material mat_ball
{
	specular_red = 255;
	specular_green = 255;
	specular_blue = 0;
	diffuse_red = 255;
	diffuse_green = 255;
	diffuse_blue = 0;
	ambient_red = 255;
	ambient_green = 255;
	ambient_blue = 0;
	emissive_red = 128;
	emissive_green = 128;
	emissive_blue = 0;
	power = 10;
	albedo = 80;
}

function shade_ball()
{
	my.material = mat_ball;
	my.transparent = on;
	my.passable = on;
	my.alpha = ball.alpha+10;
	my.z = ball.z+5;
	while(my.alpha > 0)
	{
		if(ball == null) {break;}
		my.alpha -= 90*time;
		wait(1);
	}
	created_ents -= 1;
	remove me;
}

function ball_move()
{
	while(my.moving == on)
	{
		c_move(my,vector(my.speed_x*time,my.speed_y*time,0),nullvector,ignore_passable);
		ent_animate(me,"stand",my.skill46,ANM_CYCLE);
		   my.skill46 = (my.skill46 + 8 * time) % 100; 
		wait(1);
	}
}
function dieball_effect();
function ball_healthfade()
{
		while(my.health > 0)
	{
		mat_ball.ambient_green = my.health + 1 * 2;
		mat_ball.ambient_blue = my.health + 1 * 2;
		mat_ball.diffuse_green = my.health + 1 * 2;
		mat_ball.diffuse_blue = my.health + 1 * 2;
		wait(1);
	}
	effect(dieball_effect,100,vector(my.x,my.y,my.z+10),nullvector);
	mat_ball.ambient_green = 255;
	mat_ball.ambient_blue = 0;
	mat_ball.diffuse_green = 255;
	mat_ball.diffuse_blue = 0;
	remove me;
		bunny_dead.visible = on;
		snd_play(buzzer_wav,100,0);
		sleep(5);
		bunny_dead.visible = off;
	wait(1*time);
	check_score();
	menu_score_show();
}

function _ball()
{
	ball = me;
	my.health = 100;
	my.fat = on;
	while(freeze_mode == 1) {wait(1);}
	my.enable_entity = on;
	my.enable_block = on;
	my.enable_touch = on;
	my.enable_release = on;
	my.event = ball_event;
	while(mouse_left == 1) {wait(1);}
	while(mouse_left == 0) {wait(1);}
	my.speed_x =12;//-difficult;
	if(random(1) > 0.2) {my.speed_x = abs(my.speed_x);}
	my.moving = on;
	ball_move();
	ball_healthfade();
	
}

bmap part = <red_part.pcx>;
bmap sharp_red = <flarered.tga>;
bmap sharp_green = <flaregreen.tga>;
bmap sharp_blue = <flareblue.tga>;
bmap soft_default = <flaresoft_default.tga>;
bmap soft_comet = <flaresoft_comet.tga>;
bmap soft_sky = <flaresoft_sky.tga>;
bmap soft_warm = <flaresoft_warm.tga>;
bmap soft_star = <flaresoft_star.tga>;

function change_pardir()
{
	my.vel_x -= 0.2*time;
	my.vel_y -= 0.2*time;
	my.vel_z = my.vel_z-1*time;
	my.alpha -= 0.5*time;
	if(my.alpha <= 0) {my.lifespan = 0;}
}

function particle_alpha_fade()
{
	vec_scale(my.vel_x,0.99);
	my.alpha -= 1.5*time;
	if(my.alpha < 35) {my.lifespan = 0;}
}

function test_effect()
{
	my.vel_x = random(3)+2;
	my.vel_y = random(3)+2;
	my.vel_z = 10;
	my.move = on;
	my.size = 4;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 6;
	my.bmap = part;
	my.function = change_pardir;
}

function create_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 30;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = sharp_red;
	my.function = particle_alpha_fade;
}

function scatterblue_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 10;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 50;
	my.bmap = sharp_blue;
	my.function = particle_alpha_fade;
}

function scattergreen_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 30;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = sharp_green;
	my.function = particle_alpha_fade;
}

function dieball_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 40;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_comet;
	my.function = particle_alpha_fade;
}

function dieenemy_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 15;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_default;
	my.function = particle_alpha_fade;
}

function dieenemy2_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 35;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_sky;
	my.function = particle_alpha_fade;
}

function dieenemy3_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 35;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_warm;
	my.function = particle_alpha_fade;
}

function dieenemy4_effect()
{
	my.vel_x = (random(5)+random(5))-(random(5)+random(5));
	my.vel_y = (random(5)+random(5))-(random(5)+random(5));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 25;//35
	my.flare = on;
	my.bright = on;
//	my.beam = on;
	my.streak = on;
	my.alpha = 50;//100
	my.bmap = soft_star;
	my.function = particle_alpha_fade;
}

function ball_eve()
{
	if(event_type == event_touch)
	 {cross_stat -= 1;}
	if(event_type == event_release) {cross_stat += 1;}
	return;
}

function enemy_eve()
{
	if((event_type == event_entity) || (event_type == event_block))
	{
		if(random(1) > 0.5)
		{
			my.pan += 5+random(5); //40
		}
		else
		{
			my.pan -= 5+random(5);  //40
		}
	}
	if(event_type == event_touch) {cross_stat += 1;}
	if(event_type == event_release) {cross_stat -= 1;}
	if(event_type == event_click)	//&&(my.alpha >20)
		{		
	 	my.health = 0;
	 	random_groans();
 		} 	 	
	return;
}

function enemy_move()
{
	while(me != null)
	{
		if(my.skill20 < 1)
		{
			if((_level > 4) && (_level < 9)) {my.speed_x = -_level;} 
			if(_level > 8) {my.speed_x = -_level*2;my.speed_y = -_level*1.2;} 
			if(random(1) > 0.5) {my.speed_x = abs(my.speed_x);}
			if(random(1) > 0.5) {my.speed_y = abs(my.speed_y);}
			my.skill20 = 20;
		}
		my.skill20 -= 5*time;
		c_move(my,vector(my.speed_x*time,my.speed_y*time,0),nullvector,ignore_passable);
		ent_animate(me,"stand",my.skill46,ANM_CYCLE);
		   my.skill46 = (my.skill46 +0.5* time) % 100; 
		wait(1);
	}
}

function enemy_()
{
	my.health = 10;
	my.skin = 2;
	var par[3];
	my.id = enemy;
	temp.z = c_trace(my.x,vector(my.x,my.y,-115),ignore_passable + use_box);
	my.z -= temp.z;
	my.transparent = on;
	my.alpha = 0;
	if(you != null) {remove me;}
	if(me != null)
	{
		enemy_move();
		my.enable_click = on;
		my.enable_entity = on;
		my.enable_block = on;
		my.enable_touch = on;
		my.enable_release = on;

		my.event = enemy_eve;
		  while(my.health > 0)
		  {
		   my.alpha += 4;
		   my.alpha %= 100;
		   if(my.alpha > 65) {my.transparent = off;}
		   wait(random(6)+12);
		   par.x = my.x-5;//  + random(20)-random(20);
		   par.y = my.y;//  + random(20)-random(20);
		   par.z = my.z -35;// + random(20)-random(20);
		   effect(test_effect,15,par.x,nullvector);
			
		  }

		effect(dieenemy_effect,30,my.x,nullvector);
		effect(dieenemy4_effect,30,my.x,nullvector);
		effect(dieball_effect,25,my.x,nullvector);
		_score += 1;
		remove me;
	}
}

function ball_hit()
{
	var vec1[3];
	var vec2[3];
	if(you == null)
	{
		vec1.x = my.x+10;
		vec1.y = my.y;
		vec1.z = my.z;
		result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		if(result == 0)
		{
			vec1.x = my.x;
			vec1.y = my.y+10;
			vec1.z = my.z;
			result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		}
		if(result == 0)
		{
			vec1.x = my.x;
			vec1.y = my.y-10;
			vec1.z = my.z;
			result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		}
		if(result == 0)
		{
			vec1.x = my.x-10;
			vec1.y = my.y;
			vec1.z = my.z;
			result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		}
		vec1.x = my.x+vec1.x;
		vec1.y = my.y+vec1.y;
		vec1.z = my.z+5;
	}
	else
	{
		vec_set(vec1,you.x);
		vec_set(vec2,my.x);
		vec_sub(vec1,vec2);
		vec1.x = my.x+vec1.x;
		vec1.y = my.y+vec1.y;
		vec1.z = my.z+5;
	}
	effect(scatterblue_effect,25,my.x,nullvector);  //effect when life ball hits objects
}

bmap cross_green = <cross_green.tga>;
bmap cross_red = <cross_red.tga>;
bmap cross_unable = <cross_green.tga>;
function mouse_cross()
{
	mouse_range = 5000;
	while(res_changed == 0)
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		if(freeze_mode == 0&&cross_stat < 0) {mouse_map = cross_unable;}
		if(freeze_mode == 0&&cross_stat == 0) {mouse_map = cross_green;}
		if(freeze_mode == 0&&cross_stat > 0) {mouse_map = cross_red;}
		if(freeze_mode == 0) {mouse_spot.x = bmap_width(cross_green)/2;mouse_spot.y = bmap_height(cross_green)/2;}
		if(freeze_mode == 1) {mouse_map = mouse_pcx;mouse_spot.x = 0;mouse_spot.y = 0;}
		camera.ambient = camera_ambient - 100;
		wait(1);
	}
	res_changed = 0;
}

////////////////////////////////////////////////////
// Health panel
////////////////////////////////////////////////////
bmap ball_pcx = <RABBIT.pcx>;

text time_txt()
{
	pos_x = 20;
	pos_y = 34;
	layer = 4;
	font = ball_font;
	string = "TIME: . . .";
	flags = visible,outline;
	red = 45;  //change numbers for different color, delete for white
  green = 211;
  blue = 0;
 
}

text score_txt()
{
	pos_x = 20;
	pos_y = 50;
	layer = 4;
	font = ball_font;
	string = "SCORE:";
	flags = visible,outline;
	red = 45;  //change numbers for different color, delete for white
  green = 211;
  blue = 0;
  
}

panel time_pan()
{
	layer = 5;
	flags = overlay,visible;
	digits = 82,34,6,ball_font,1,_time;
}

panel score_pan()
{
	layer = 5;
	flags = overlay,visible;
	digits = 82,50,6,ball_font,1,_score;
}

function stats_on()
{
	time_txt.visible = on;
	score_txt.visible = on;
	time_pan.visible = on;
	score_pan.visible = on;
}

function stats_off()
{
	time_txt.visible = off;
	score_txt.visible = off;	
	time_pan.visible = off;
	score_pan.visible = off;
}

panel ball_hp100()
{
	bmap = ball_pcx;
	pos_x = 110;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

panel ball_hp80()
{
	bmap = ball_pcx;
	pos_x = 85;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

panel ball_hp60()
{
	bmap = ball_pcx;
	pos_x = 60;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

panel ball_hp40()
{
	bmap = ball_pcx;
	pos_x = 35;
	pos_y = 5;
	layer = 10;
	alpha = 10;
	flags = transparent,refresh,overlay;
}

panel ball_hp20()
{
	bmap = ball_pcx;
	pos_x = 10;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

function show_health()
{
	ball_hp100.visible = on;
	ball_hp80.visible = on;
	ball_hp60.visible = on;
	ball_hp40.visible = on;
	ball_hp20.visible = on;
	ball_hp100.alpha = 0;
	ball_hp80.alpha = 0;
	ball_hp60.alpha = 0;
	ball_hp40.alpha = 0;
	ball_hp20.alpha = 0;
	while(ball != null)
	{
		if(ball.health < 81)
		{
			if(ball_hp100.alpha > 0) {ball_hp100.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp100.alpha < 100) {ball_hp100.alpha += 25*time;}
		}
		
		if(ball.health < 61)
		{
			if(ball_hp80.alpha > 0) {ball_hp80.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp80.alpha < 100) {ball_hp80.alpha += 25*time;}
		}
		
		if(ball.health < 41)
		{
			if(ball_hp60.alpha > 0) {ball_hp60.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp60.alpha < 100) {ball_hp60.alpha += 25*time;}
		}
		
		if(ball.health < 21)
		{
			if(ball_hp40.alpha > 0) {ball_hp40.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp40.alpha < 100) {ball_hp40.alpha += 25*time;}
		}
		
		if(ball.health < 2)
		{
			if(ball_hp20.alpha > 0) {ball_hp20.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp20.alpha < 100) {ball_hp20.alpha += 25*time;}
		}
		wait(1);
	}
	ball_hp100.visible = off;
	ball_hp80.visible = off;
	ball_hp60.visible = off;
	ball_hp40.visible = off;
	ball_hp20.visible = off;
}


text e1_txt()
{
	font = arial_font;
	layer = 10;
	string = easy1;
}

text e2_txt()
{
	font = arial_font;
	layer = 10;
	string = easy2;
}

text e3_txt()
{
	font = arial_font;
	layer = 10;
	string = easy3;
}

text m1_txt()
{
	font = arial_font;
	layer = 10;
	string = medi1;
}

text m2_txt()
{
	font = arial_font;
	layer = 10;
	string = medi2;
}

text m3_txt()
{
	font = arial_font;
	layer = 10;
	string = medi3;
}

text h1_txt()
{
	font = arial_font;
	layer = 10;
	string = hard1;
}

text h2_txt()
{
	font = arial_font;
	layer = 10;
	string = hard2;
}

text h3_txt()
{
	font = arial_font;
	layer = 10;
	string = hard3;
}

function score_txt_hide()
{
	
	e1_txt.visible = off;
	e2_txt.visible = off;
	e3_txt.visible = off;
	m1_txt.visible = off;
	m2_txt.visible = off;
	m3_txt.visible = off;
	h1_txt.visible = off;
	h2_txt.visible = off;
	h3_txt.visible = off;
}

function score_txt_show()
{
	
	e1_txt.pos_x = high_score.pos_x+250;
	e2_txt.pos_x = high_score.pos_x+250;
	e3_txt.pos_x = high_score.pos_x+250;
	m1_txt.pos_x = high_score.pos_x+250;
	m2_txt.pos_x = high_score.pos_x+250;
	m3_txt.pos_x = high_score.pos_x+250;
	h1_txt.pos_x = high_score.pos_x+250;
	h2_txt.pos_x = high_score.pos_x+250;
	h3_txt.pos_x = high_score.pos_x+250;

	e1_txt.pos_y = high_score.pos_y+40;
	e2_txt.pos_y = high_score.pos_y+55;
	e3_txt.pos_y = high_score.pos_y+70;
	m1_txt.pos_y = high_score.pos_y+120;
	m2_txt.pos_y = high_score.pos_y+135;
	m3_txt.pos_y = high_score.pos_y+150;
	h1_txt.pos_y = high_score.pos_y+202;
	h2_txt.pos_y = high_score.pos_y+217;
	h3_txt.pos_y = high_score.pos_y+232;
	
	e1_txt.visible = on;
	e2_txt.visible = on;
	e3_txt.visible = on;
	m1_txt.visible = on;
	m2_txt.visible = on;
	m3_txt.visible = on;
	h1_txt.visible = on;
	h2_txt.visible = on;
	h3_txt.visible = on;
}

function menu_score_show()
{	
	menu_options.visible = off;
	menu_difficult.visible = off;
	menu_back.visible = off;
	high_score.visible = on;
	high_score.pos_x = (screen_size.x-bmap_width(score_map))/2;
	high_score.pos_y = (screen_size.y-bmap_height(score_map))/2;
	score_txt_show();
	freeze_mode = 1;
	media_stop(stop_mid);
}

function read_high_score()
{
	filehandle = file_open_read("records.sco");
	if(filehandle != 0)
	{
		e_records[0] = file_var_read(filehandle);
		file_str_read(filehandle,easy1);
		e_records[1] = file_var_read(filehandle);
		file_str_read(filehandle,easy2);
		e_records[2] = file_var_read(filehandle);
		file_str_read(filehandle,easy3);
		
		m_records[0] = file_var_read(filehandle);
		file_str_read(filehandle,medi1);
		m_records[1] = file_var_read(filehandle);
		file_str_read(filehandle,medi2);
		m_records[2] = file_var_read(filehandle);
		file_str_read(filehandle,medi3);
		
		h_records[0] = file_var_read(filehandle);
		file_str_read(filehandle,hard1);
		h_records[1] = file_var_read(filehandle);
		file_str_read(filehandle,hard2);
		h_records[2] = file_var_read(filehandle);
		file_str_read(filehandle,hard3);
		file_close(filehandle);
	}
	if(str_cmpni(easy1,",0") == 1) {str_cpy(easy1,"                        ");}
	if(str_cmpni(easy2,",0") == 1) {str_cpy(easy2,"                        ");}
	if(str_cmpni(easy3,",0") == 1) {str_cpy(easy3,"                        ");}
	if(str_cmpni(medi1,",0") == 1) {str_cpy(medi1,"                        ");}
	if(str_cmpni(medi2,",0") == 1) {str_cpy(medi2,"                        ");}
	if(str_cmpni(medi3,",0") == 1) {str_cpy(medi3,"                        ");}
	if(str_cmpni(hard1,",0") == 1) {str_cpy(hard1,"                        ");}
	if(str_cmpni(hard2,",0") == 1) {str_cpy(hard2,"                        ");}
	if(str_cmpni(hard3,",0") == 1) {str_cpy(hard3,"                        ");}
}

function rewrite_high_score()
{
	filehandle = file_open_write("records.sco");
	file_var_write(filehandle,e_records[0]);
	file_str_write(filehandle,easy1);
	file_str_write(filehandle,",");
	file_var_write(filehandle,e_records[1]);
	file_str_write(filehandle,easy2);
	file_str_write(filehandle,",");
	file_var_write(filehandle,e_records[2]);
	file_str_write(filehandle,easy3);
	file_str_write(filehandle,",");
	
	file_var_write(filehandle,m_records[0]);
	file_str_write(filehandle,medi1);
	file_str_write(filehandle,",");
	file_var_write(filehandle,m_records[1]);
	file_str_write(filehandle,medi2);
	file_str_write(filehandle,",");
	file_var_write(filehandle,m_records[2]);
	file_str_write(filehandle,medi3);
	file_str_write(filehandle,",");
	
	file_var_write(filehandle,h_records[0]);
	file_str_write(filehandle,hard1);
	file_str_write(filehandle,",");
	file_var_write(filehandle,h_records[1]);
	file_str_write(filehandle,hard2);
	file_str_write(filehandle,",");
	file_var_write(filehandle,h_records[2]);
	file_str_write(filehandle,hard3);
	file_str_write(filehandle,",");
	file_close(filehandle);
}

function check_score()
{
	score_pan.visible = on;
	inkey_active = off;
	wait(1);
	if(difficult < 40)
	{
		if(_score > e_records[0])
		{
			e_records[2] = e_records[1];
			e_records[1] = e_records[0];
			e_records[0] = _score;
			str_cpy(easy3,easy2);
			str_cpy(easy2,easy1);
			str_cpy(easy1,"                         ");
			inkey(easy1);
		}
		else
		{
			if(_score > e_records[1])
			{
				e_records[2] = e_records[1];
				e_records[1] = _score;
				str_cpy(easy3,easy2);
				str_cpy(easy2,"                         ");
				inkey(easy2);
			}
			else
			{
				if(_score > e_records[2])
				{
					e_records[2] = _score;
					str_cpy(easy3,"                         ");
					inkey(easy3);
				}
			}
		}
	}
	
	if(difficult == 40)
	{
		if(_score > m_records[0])
		{
			m_records[2] = m_records[1];
			m_records[1] = m_records[0];
			m_records[0] = _score;
			str_cpy(medi3,medi2);
			str_cpy(medi2,medi1);
			str_cpy(medi1,"                         ");
			inkey(medi1);
		}
		else
		{
			if(_score > m_records[1])
			{
				m_records[2] = m_records[1];
				m_records[1] = _score;
				str_cpy(medi3,medi2);
				str_cpy(medi2,"                         ");
				inkey(medi2);
			}
			else
			{
				if(_score > m_records[2])
				{
					m_records[2] = _score;
					str_cpy(medi3,"                         ");
					inkey(medi3);
				}
			}
		}
	}
	
	if(difficult > 40)
	{
		if(_score > h_records[0])
		{
			h_records[2] = h_records[1];
			h_records[1] = h_records[0];
			h_records[0] = _score;
			str_cpy(hard3,hard2);
			str_cpy(hard2,hard1);
			str_cpy(hard1,"                         ");
			inkey(hard1);
		}
		else
		{
			if(_score > h_records[1])
			{
				h_records[2] = h_records[1];
				h_records[1] = _score;
				str_cpy(hard3,hard2);
				str_cpy(hard2,"                         ");
				inkey(hard2);
			}
			else
			{
				if(_score > h_records[2])
				{
					h_records[2] = _score;
					str_cpy(hard3,"                         ");
					inkey(hard3);
				}
			}
		}
	}
}

